=head1 NAME

nbdkit-perl-plugin - nbdkit perl plugin

=head1 SYNOPSIS

 nbdkit perl /path/to/plugin.pl [arguments...]

=head1 DESCRIPTION

C<nbdkit-perl-plugin> is an embedded Perl interpreter for
L<nbdkit(1)>, allowing you to write nbdkit plugins in Perl.

=head2 If you have been given an nbdkit Perl plugin

Assuming you have a Perl script which is an nbdkit plugin, you run it
like this:

 nbdkit perl /path/to/plugin.pl

You may have to add further C<key=value> arguments to the command
line.  Read the Perl script to see if it requires any.

=head1 WRITING A PERL NBDKIT PLUGIN

For an example plugin written in Perl, see:
L<https://gitlab.com/nbdkit/nbdkit/blob/master/plugins/perl/example.pl>

Broadly speaking, Perl nbdkit plugins work like C ones, so you should
read L<nbdkit-plugin(3)> first.

To write a Perl nbdkit plugin, you create a Perl file which contains
at least the following required subroutines:

 sub open
 {
   # see below
 }
 sub get_size
 {
   # see below
 }
 sub pread
 {
   # see below
 }

Note that the subroutines must have those literal names (like
C<open>), because the C part looks up and calls those functions
directly.  You may want to include documentation and globals (eg. for
storing global state).  Also any top-level statements, C<BEGIN>
statements, C<END> statements and so on are run when nbdkit starts up
and shuts down, just like ordinary Perl.

=head2 Executable script

If you want you can make the script executable and include a "shebang"
at the top:

 #!/usr/sbin/nbdkit perl

See also L<nbdkit(1)/Shebang scripts>.

These scripts can also be installed in the C<$plugindir>.  See
L<nbdkit-plugin(3)/WRITING PLUGINS IN OTHER PROGRAMMING LANGUAGES>.

=head2 C<Nbdkit::> functions

The following functions can be called in a virtual Perl package called
C<Nbdkit>.  Your script does not need to "use" this package, it is
already available in all scripts.

=head3 C<Nbdkit::debug ($msg)>

In debugging mode, print C<$msg>.  This is a wrapper around the C
function L<nbdkit_debug(3)> (see L<nbdkit-plugin(3)>).

=head3 C<Nbdkit::set_error ($err)>

 Nbdkit::set_error($err);

Record C<$err> as the reason you are about to throw an exception.
C<$err> should correspond to usual errno values, where it may help to
C<use POSIX()>.

=head2 Exceptions

Instead of returning error codes as in C, Perl callbacks should
indicate problems by throwing Perl exceptions (ie. C<die>, C<croak>
etc).  The Perl error message is captured and printed by nbdkit.
Remember to use C<Nbdkit::set_error> if you need to control which
error is sent back to the client; if omitted, the client will see an
error of C<EIO>.

=head2 32 vs 64 bit

It is likely that Perl plugins won't work well, or maybe won't work at
all, on 32 bit platforms.  This is simply because Perl doesn't have an
easy way to use 64 bit integers on 32 bit platforms, and 64 bit
integers (eg. file offsets, disk sizes) are required for many nbdkit
operations.

=head2 Perl callbacks

This just documents the arguments to the callbacks in Perl, and any
way that they differ from the C callbacks.  In all other respects they
work the same way as the C callbacks, so you should go and read
L<nbdkit-plugin(3)>.

=over 4

=item C<dump_plugin>

(Optional)

There are no arguments or return value.

=item C<config>

(Optional)

 sub config
 {
     my $key = shift;
     my $value = shift;
     # No return value.
 }

=item C<config_complete>

(Optional)

There are no arguments or return value.

=item C<open>

(Required)

 sub open
 {
     my $readonly = shift;
     my $handle = {};
     return $handle;
 }

The C<readonly> flag is a boolean.

You can return any Perl value as the handle.  It is passed back to
subsequent calls.  It's usually convenient to use a hashref, since
that lets you store arbitrary fields.

=item C<close>

(Optional)

 sub close
 {
     my $handle = shift;
     # No return value
 }

After C<close> returns, the reference count of the handle is
decremented in the C part, which usually means that the handle and its
contents will be garbage collected.

=item C<get_size>

(Required)

 sub get_size
 {
     my $handle = shift;
     my $i64 = .. the size of the disk ..;
     return $i64;
 }

This returns the size of the disk.  You can return any Perl object
that evaluates to an integer.

=item C<can_write>

(Optional)

 sub can_write
 {
     my $handle = shift;
     my $bool = ...;
     return $bool;
 }

Return a boolean indicating whether the disk is writable.

=item C<can_flush>

(Optional)

 sub can_flush
 {
     my $handle = shift;
     my $bool = ...;
     return $bool;
 }

Return a boolean indicating whether flush can be performed.

=item C<is_rotational>

(Optional)

 sub is_rotational
 {
     my $handle = shift;
     my $bool = ...;
     return $bool;
 }

Return a boolean indicating whether the disk is rotational.

=item C<can_trim>

(Optional)

 sub can_trim
 {
     my $handle = shift;
     my $bool = ...;
     return $bool;
 }

Return a boolean indicating whether trim/discard can be performed.

=item C<pread>

(Required)

 sub pread
 {
    my $handle = shift;
    my $count = shift;
    my $offset = shift;
    my $flags = shift;
    # Construct a buffer of length $count bytes and return it.
    return $buf;
 }

The body of your C<pread> function should construct a buffer of length
(at least) C<$count> bytes.  You should read C<$count> bytes from the
disk starting at C<$offset>.

NBD only supports whole reads, so your function should try to read the
whole region (perhaps requiring a loop).  If the read fails or is
partial, your function should C<die>, optionally using
C<Nbdkit::set_error> first.

=item C<pwrite>

(Optional)

 sub pwrite
 {
    my $handle = shift;
    my $buf = shift;
    my $count = length ($buf);
    my $offset = shift;
    my $flags = shift;
    # No return value
 }

The body of your C<pwrite> function should write the C<$buf> string to
the disk.  You should write C<$count> bytes to the disk starting at
C<$offset>.

NBD only supports whole writes, so your function should try to write
the whole region (perhaps requiring a loop).  If the write fails or is
partial, your function should C<die>, optionally using
C<Nbdkit::set_error> first.

=item C<flush>

(Optional)

 sub flush
 {
    my $handle = shift;
    my $flags = shift;
    # No return value
 }

The body of your C<flush> function should do a L<sync(2)> or
L<fdatasync(2)> or equivalent on the backing store.

If there is an error, the function should call C<die>, optionally using
C<Nbdkit::set_error> first.

=item C<trim>

(Optional)

 sub trim
 {
    my $handle = shift;
    my $count = shift;
    my $offset = shift;
    my $flags = shift;
    # No return value
 }

The body of your C<trim> function should "punch a hole" in the backing
store.

If there is an error, the function should call C<die>, optionally using
C<Nbdkit::set_error> first.

=item C<zero>

(Optional)

 sub zero
 {
    my $handle = shift;
    my $count = shift;
    my $offset = shift;
    my $flags = shift;
    # No return value
 }

The body of your C<zero> function should ensure that C<$count> bytes
of the disk, starting at C<$offset>, will read back as zero.

NBD only supports whole writes, so your function should try to write
the whole region (perhaps requiring a loop).  If the write fails or is
partial, your function should C<die>, optionally using
C<Nbdkit::set_error> first.  In particular, if you would like to
automatically fall back to C<pwrite> (perhaps because there is nothing
to optimize if C<$flags> does not contain C<$Nbdkit::FLAG_MAY_TRIM>), use
C<Nbdkit::set_error(POSIX::EOPNOTSUPP)>.

=back

=head2 Missing callbacks

=over 4

=item Missing: C<load> and C<unload>

These are not needed because you can just use regular Perl C<BEGIN>
and C<END> constructs.

=item Missing: C<name>, C<version>, C<longname>, C<description>,
C<config_help>, C<can_fua>, C<can_cache>, C<cache>

These are not yet supported.

=back

=head2 Threads

The thread model for Perl callbacks currently cannot be set from Perl.
It is hard-coded in the C part to
C<NBDKIT_THREAD_MODEL_SERIALIZE_ALL_REQUESTS>.  This may change or be
settable in future.

=head1 FILES

=over 4

=item F<$plugindir/nbdkit-perl-plugin.so>

The plugin.

Use C<nbdkit --dump-config> to find the location of C<$plugindir>.

=back

=head1 VERSION

C<nbdkit-perl-plugin> first appeared in nbdkit 1.2.

=head1 SEE ALSO

L<nbdkit(1)>,
L<nbdkit-plugin(3)>,
L<perl(1)>.

=head1 AUTHORS

Eric Blake

Richard W.M. Jones

=head1 COPYRIGHT

Copyright Red Hat
